/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.ui;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

/**
 * 翻訳パースペクティブのファクトリーです。
 */
public class TranslationPerspectiveFactory implements IPerspectiveFactory {

	private static final String ID_PROJECT_EXPLORER = "org.eclipse.ui.navigator.ProjectExplorer";
	private static final String ID_TRANSLATION = "benten.cat.tm.ui.views.TranslationView";
	private static final String ID_GLOSSARY = "benten.cat.glossary.ui.views.GlossaryView";

	public void createInitialLayout(IPageLayout layout) {
		defineActions(layout);
		defineLayout(layout);
	}

	protected void defineActions(IPageLayout layout) {
	}

	protected void defineLayout(IPageLayout layout) {

		final String editorArea = layout.getEditorArea();

		final IFolderLayout bottomLeft = layout
				.createFolder("bottomLeft", IPageLayout.BOTTOM, (float) 0.75, editorArea);
		bottomLeft.addView(ID_TRANSLATION);
		bottomLeft.addView(ID_GLOSSARY);

		final IFolderLayout bottomRight = layout.createFolder("bottomRight", IPageLayout.RIGHT, (float) 0.4,
				"bottomLeft");
		bottomRight.addView(IPageLayout.ID_PROBLEM_VIEW);

		final IFolderLayout left = layout.createFolder("left", IPageLayout.LEFT, (float) 0.25, editorArea);
		left.addView(ID_PROJECT_EXPLORER);
		left.addView(IPageLayout.ID_OUTLINE);
	}
}
